#include	<avr/io.h>
#include	<stdio.h>
#include	"lcd.h"
#include	"usart.h"

static FILE usart1_stdio = FDEV_SETUP_STREAM(USART1_send, USART1_receive, _FDEV_SETUP_RW);

// main Լ
int	main(void)
{	char lcd_string[2][MAX_LCD_STRING];
	int	x, sum;
	
	LCD_init();
	USART_init(USART1, 12);		// USART1 Ʈ : 38400(UBRR=12), 8MHz

	sprintf(lcd_string[0], "   USART1 Test   ");	// LCD 
	LCD_str_write(0, 0, lcd_string[0]);

	stdin = stdout = stderr = &usart1_stdio;
	printf("%s", lcd_string[0]);	// USART1 ׽Ʈ 
	
	while(1){
		printf("\r\nSumming 1 ~ x, Type X=?.?");
		scanf("%d", &x);	//  x Է
		
		for(sum=0; x > 0; sum += x--);
		sprintf(lcd_string[1], "\r\nSum = %-4d  ", sum);

		printf("%s", lcd_string[1]);		// 濡  * ǵ 
		LCD_str_write(1, 0, lcd_string[1]);
	}

	return 0;
}
