#include	<avr/io.h>
#include	<avr/interrupt.h>
#include	"spi_thermometer.h"

// ǻü µ, ȯ µ
volatile	int	temp_obj, temp_air;
volatile	int	req_spi = 0;

ISR(SPI_STC_vect)
{	req_spi = req_spi > 0 ? req_spi - 1 : 0;	// Ÿ 1 

	if( SPDR == 0xA1 ){	// ù 
		req_spi = 4;
		return;
	}

	switch(req_spi){
		case 3:
			temp_obj = (unsigned int)SPDR << 8;
			break;

		case 2:
			temp_obj |= (unsigned int)SPDR;
			break;

		case 1:
			temp_air = (unsigned int)SPDR << 8;
			break;

		case 0:
			temp_air |= (unsigned int)SPDR;
			break;

		default: ;
	}
}

void	SPI_slave_init(void)
{
	SPCR |= 1<<SPE | 1<<DORD;	  // SPI Ȱȭ, LSB  ó, ̺
	SPCR |= 1<<CPOL| 1<<CPHA;  // Ŭ  1, ¿ ø
}
