#include	 <avr/io.h>
#include	 <avr/interrupt.h>

#define	F_CPU	16000000L
#define	OC2	PB7

#define	PRESCALE		1024L
#define	OCR_NUTRAL	(int)((0.0015*F_CPU)/PRESCALE - 1)
#define	OCR_PER_DEG	((double)((0.0008*F_CPU)/(double)(PRESCALE*90.0)))

volatile	unsigned	long	timer2;		// ÷θ 1  
volatile	unsigned	int	number;
unsigned char led[] = {0x48, 0x7D, 0xC4, 0x64, 0x71, 0x62, 0x43, 0x7C, 0x40, 0x70};

// Ÿ̸/ī0 ͷƮ  ƾ
ISR(TIMER2_OVF_vect)
{
	timer2++;		                 // ÷θ 1 
	
	// ÷ Ƚ ¦  10ڸ, Ȧ  1ڸ ÷
	PORTC = (timer2 % 2 == 0) ? led[(number % 100) / 10] : led[number%10];
	PORTD = (PORTD |0xC0) & ~(1<<((timer2 % 2 == 0) ? PD7 : PD6));
}

int	main(void)
{	
	DDRC = 0xFF;
	DDRD |= 1<<PD7 | 1<<PD6;	//  ڸ 7-׸Ʈ LED ѱ 
	DDRB |= 1<<OC2;		// OC2 = PB7 

	TCCR2 = 1<<WGM21 | 1<<WGM20;	//  PWM  ߻
	TCCR2 |= 1<<CS22 | 1<<CS20;	// Ϸ CS22:20 = (1,0,1) 1024 
	TCCR2 |= 1<<COM01;		// TCNT0 0xFF 1,   OCR0 ġϸ 0
	
	TIMSK |= 1<<TOIE2;		// Ÿ̸/ī0 ͷƮ Ȱȭ
	
	timer2 = 0;
	sei();

	OCR2 = OCR_NUTRAL + 0*OCR_PER_DEG;
	number = OCR2;		// OCR0  number  ġ
	
	while(1);		         //  loop
	return 0;
}
