#include	<stdio.h>
#include	<avr/io.h>
#include	<avr/interrupt.h>
#include	<util/delay.h>
#include	"lcd.h"
#include	"spi_adc.h"

#define	DELAY_MSEC	150
extern volatile	int	spi_mode;

volatile unsigned	int	my_adc, remote_adc;

// A/D ȯ Ϸ
ISR(ADC_vect)	
{	my_adc = ADC;	}

// A/D ȯ ʱȭ
void ADC_init(void)
{	// ADC Ȱȭ, ADC ͷƮ Ȱȭ, Ϸ CPU ֺ=64
	ADCSRA |= 1<<ADEN | 1<<ADIE | 6;	
}

void	display_spi_adc(void)
{	char lcd_string[2][MAX_LCD_STRING];

	sprintf(lcd_string[0], "SPI-ADC %6s", spi_mode==MASTER ? "Master" : "Slave");
	sprintf(lcd_string[1], "Me:%-4dRemo:%-4d", my_adc, remote_adc);
	LCD_str_write(0, 0, lcd_string[0]);
	LCD_str_write(1, 0, lcd_string[1]);
}

// main Լ
int	main(void)
{
	ADC_init();
	LCD_init();
	SPI_init();
	sei();

	while(1){
		display_spi_adc();		// my_adc remote_adc ÷
		_delay_ms(DELAY_MSEC);

		master_get_slave_ADC();	// ͷμ  ְ

		ADCSRA |= 1<<ADSC;		// A/D ȯ 

		display_spi_adc();		// my_adc remote_adc ÷
		_delay_ms(DELAY_MSEC);
	}

	return 0;
}
